//------------------------------------------------------------------------------
// shape_Constr.cpp -     
//     
//------------------------------------------------------------------------------

#include <iostream>
#include "shape_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .

  rectangle *Create_rectangle(int x, int y);
  triangle  *Create_triangle(int a, int b, int c);
  void Init(rectangle &r, int x, int y);
  void Init(triangle &t, int a, int b, int c);

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_rectangle(int x, int y)
  {
    shape *s = new shape;
    s->k = shape::key::RECTANGLE;
    s->pr = Create_rectangle(x, y);
    return s;
  }

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_triangle(int a, int b, int c)
  {
    shape *s = new shape;
    s->k = shape::key::TRIANGLE;
    s->pt = Create_triangle(a, b, c);
    return s;
  }

//------------------------------------------------------------------------------

  //   
  void Init_rectangle(shape &s, int x, int y)
  {
    s.k = shape::key::RECTANGLE;
    Init(*(s.pr), x, y);
  }

//------------------------------------------------------------------------------

  //   
  void Init_triangle(shape &s, int a, int b, int c)
  {
    s.k = shape::key::TRIANGLE;
    Init(*(s.pt), a, b, c);
  }

//------------------------------------------------------------------------------

  //     
  void Clear(shape &s)
  {
    //     
    switch(s.k)
    {
    case shape::key::RECTANGLE:
      delete s.pr;
      break;
    case shape::key::TRIANGLE:
      delete s.pt;
      break;
    }
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
